<template>
  <div>
    <h2> Dodaj swoje dane: </h2>
    <form
        v-on:submit.prevent="submitForm"
    >

      <div class="form-group">
        <label for="beekeperName">Twoje imię: </label>
        <input type="text" class="form-control" id="beekeperName" placeholder="Imię"
               maxlength="20"
               v-model="form.beekeperName" required>
      </div>

      <div class="form-group">
        <label for="beekeperSurname">Twoje nazwisko: </label>
        <input type="text" class="form-control" id="beekeperSurname" placeholder="Nazwisko" maxlength="20"
               v-model="form.beekeperSurname" required>
      </div>

      <div class="form-group">
        <label for="email">Twój email: </label>
        <input type="text" class="form-control" id="email" placeholder="email" maxlength="50"
               v-model="form.email" required>
      </div>

      <div class="form-group">
        <label for="postCode">Twój kod pocztowy: </label>
        <input type="text" class="form-control" id="postCode" placeholder="dd-ddd" pattern="^[0-9]{2}-[0-9]{3}$"
               maxlength="9" v-model="form.postCode" required>
      </div>

      <div class="form-group">
        <label for="city">Twoje miejsce zamieszkania: </label>
        <input type="text" class="form-control" id="city" placeholder="Miasto" maxlength="20"
               v-model="form.city" required>
      </div>

      <div class="form-group">
        <label for="road">Ulica: </label>
        <input type="text" class="form-control" id="road" placeholder="Ulica" maxlength="20"
               v-model="form.road" required>
      </div>

      <div class="form-group">
        <label for="roadNr">Nr. ulicy: </label>
        <input type="text" class="form-control" id="roadNr" placeholder="Nr" maxlength="10"
               v-model="form.roadNr" required>
      </div>

      <div class="form-group">
        <button class="btn btn-primary">Dodaj</button>
      </div>
    </form>
  </div>
</template>

<script>
import UserService from '../../services/user.service';
import userdetailsobject from '../../models/userdetailsobject.js'

export default {
  name: 'AddUserDetails',
  data() {
    return {
      form: new userdetailsobject('', '', '', '', '', '', '', ''),
      response: ''
    }
  },
  computed: {
    currentUser() {
      return this.$store.state.auth.user;
    }
  },
  methods: {

    submitForm() {
      if (!this.currentUser) {
        this.$router.push('/login');
      } else if (this.validEmail(this.form.email)) {

        this.form.user = {username: this.currentUser.username}

        UserService.addNewUserDetails(this.form).then(
            response => {
              this.response = response.data;
              alert('Dane dodane poprawnie')
              this.$router.push('/profile');
            },
            error => {
              this.response =
                  (error.response && error.response.data && error.response.data.message) ||
                  error.message ||
                  error.toString();
            }
        )

      } else if (!this.validEmail(this.form.email)) {
        alert('Podaj poprawny email!')
      }
    },

    validEmail: function (email) {
      let re = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
      return re.test(email);
    }
  }
};

</script>

<style scoped>
label {
  display: block;
  margin-top: 10px;
}

</style>